from typing import Literal

contracts = {
    "token": {
        "WHYPE": {
            "address": "0x533282e205e316f2639F2709CcC9392309031390",
            "decimals": 18,
            "name": "WHYPE",
            "pool": "0x754B983af92d18EBeE964782F375997066fd4064",
        }
    },
    "router": {
        "above_below": "0xE23D5097ffc238665Ef07067226fA5c1eAbF880C",
        "up_down": "0x326f6FDa239B090D69C4E29D4d23f0236D2fC367",
    },
    "account_registry": "0xb187FB0AD8CF3A0004146Af8eD7caE9e5697c489",
}
chain = {
    "id": 999,
    "rpc": "https://rpc.hyperliquid.xyz/evm",
    "explorer": "https://purrsec.com/",
    "multicall": "0xF09D72644351310B2743616883EEA8545158D014",
    "native_token": "HYPE",
    "decimals": 18,
    "name": "Hyperliquid",
}
zero_address = "0x0000000000000000000000000000000000000000"

token_keys = list(contracts["token"].keys())
ValidTokens = Literal["WHYPE"]  # Add more tokens as needed
ValidProducts = Literal["above_below", "up_down"]
ValidPriceProviders = Literal["pyth"]
exchange_remote_hosts = {
    "indexer": "https://indexer.supurr.app/",
    "api": "https://api.supurr.app/",
    "pyth": "https://hermes.pyth.network/api/latest_price_feeds",
}

pyth_info = {
    "BTCUSD": {
        "category": "Crypto",
        "tv_id": "BTCUSD",
        "pair": "BTC-USD",
        "price_precision": 100,
        "token0": "BTC",
        "token1": "USD",
        "full_name": "Bitcoin",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/btc.svg",
        "pythId": "0xe62df6c8b4a85fe1a67db44dc12de5db330f7ac66b72dc658afedf0f4a415b43",
        "pythGroup": "Crypto",
        "expo": 8,
    },
    "TRUMPUSD": {
        "category": "Crypto",
        "tv_id": "TRUMPUSD",
        "pair": "TRUMP-USD",
        "price_precision": 100,
        "token0": "TRUMP",
        "token1": "USD",
        "full_name": "Trump Coin",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/btc.svg",
        "pythId": "0xe62df6c8b4a85fe1a67db44dc12de5db330f7ac66b72dc658afedf0f4a415b43",
        "pythGroup": "Crypto",
        "expo": 8,
    },
    "ETHUSD": {
        "category": "Crypto",
        "tv_id": "ETHUSD",
        "pair": "ETH-USD",
        "price_precision": 100,
        "token0": "ETH",
        "token1": "USD",
        "full_name": "Ethereum",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/btc.svg",
        "pythId": "0xff61491a931112ddf1bd8147cd1b641375f79f5825126d665480874634fd0ace",
        "pythGroup": "Crypto",
        "expo": 8,
    },
    "EURUSD": {
        "category": "Forex",
        "tv_id": "EURUSD",
        "pair": "EUR-USD",
        "price_precision": 1000000,
        "token0": "EUR",
        "token1": "USD",
        "full_name": "Euro",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/euro.png",
        "pythId": "0xa995d00bb36a63cef7fd2c287dc105fc8f3d93779f062f09551b0af3e81ec30b",
        "pythGroup": "FX",
        "expo": 5,
    },
    "GBPUSD": {
        "category": "Forex",
        "tv_id": "GBPUSD",
        "pair": "GBP-USD",
        "price_precision": 1000000,
        "token0": "GBP",
        "token1": "USD",
        "full_name": "Pound",
        "img": "https://cdn.buffer.finance/Buffer-Media/main/GBP.png",
        "pythId": "0x84c2dde9633d93d1bcad84e7dc41c9d56578b7ec52fabedc1f335d673df0a7c1",
        "pythGroup": "FX",
        "expo": 5,
    },
    "SOLUSD": {
        "category": "Crypto",
        "tv_id": "SOLUSD",
        "pair": "SOL-USD",
        "price_precision": 100,
        "token0": "SOL",
        "token1": "USD",
        "full_name": "Solana",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/sol.svg",
        "pythId": "0xef0d8b6fda2ceba41da15d4095d1da392a0d2f8ed0c6c7bc0f4cfac8c280b56d",
        "pythGroup": "Crypto",
        "expo": 8,
    },
    "LINKUSD": {
        "category": "Crypto",
        "tv_id": "LINKUSD",
        "pair": "LINK-USD",
        "price_precision": 10000,
        "token0": "LINK",
        "token1": "USD",
        "full_name": "Chainlink",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/link.svg",
        "pythId": "0x8ac0c70fff57e9aefdf5edf44b51d62c2d433653cbb2cf5cc06bb115af04d221",
        "pythGroup": "Crypto",
        "expo": 8,
    },
    "XAUUSD": {
        "category": "Commodity",
        "tv_id": "XAUUSD",
        "pair": "XAU-USD",
        "price_precision": 100,
        "token0": "XAU",
        "token1": "USD",
        "full_name": "Gold",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/xau.svg",
        "pythId": "0x765d2ba906dbc32ca17cc11f5310a89e9ee1f6420508c63861f2f8ba4ee34bb2",
        "pythGroup": "Metal",
        "expo": 3,
    },
    "XAGUSD": {
        "category": "Commodity",
        "tv_id": "XAGUSD",
        "pair": "XAG-USD",
        "price_precision": 1000,
        "token0": "XAG",
        "token1": "USD",
        "full_name": "Silver",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/xag.svg",
        "pythId": "0xf2fb02c32b055c805e7238d628e5e9dadef274376114eb1f012337cabe93871e",
        "pythGroup": "Metal",
        "expo": 5,
    },
    "AUDUSD": {
        "category": "Forex",
        "tv_id": "AUDUSD",
        "pair": "AUD-USD",
        "price_precision": 1000000,
        "token0": "AUD",
        "token1": "USD",
        "full_name": "Australian Dollar",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/aud1.svg",
        "pythId": "0x67a6f93030420c1c9e3fe37c1ab6b77966af82f995944a9fefce357a22854a80",
        "pythGroup": "FX",
        "expo": 5,
    },
    "USDJPY": {
        "category": "Forex",
        "tv_id": "USDJPY",
        "pair": "USD-JPY",
        "price_precision": 1000000,
        "token0": "USD",
        "token1": "JPY",
        "full_name": "United States Dollar",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/USDC.svg",
        "pythId": "0xef2c98c804ba503c6a707e38be4dfbb16683775f195b091252bf24693042fd52",
        "pythGroup": "FX",
        "expo": 3,
    },
    "NZDUSD": {
        "category": "Forex",
        "tv_id": "NZDUSD",
        "pair": "NZD-USD",
        "price_precision": 1000000,
        "token0": "NZD",
        "token1": "USD",
        "full_name": "New Zealand Dollar",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/nzd.svg",
        "pythId": "0x92eea8ba1b00078cdc2ef6f64f091f262e8c7d0576ee4677572f314ebfafa4c7",
        "pythGroup": "FX",
        "expo": 5,
    },
    "USDCHF": {
        "category": "Forex",
        "tv_id": "USDCHF",
        "pair": "USD-CHF",
        "price_precision": 1000000,
        "token0": "USD",
        "token1": "CHF",
        "full_name": "United States Dollar",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/USDC.svg",
        "pythId": "0x0b1e3297e69f162877b577b0d6a47a0d63b2392bc8499e6540da4187a63e28f8",
        "pythGroup": "FX",
        "expo": 5,
    },
    "USDCAD": {
        "category": "Forex",
        "tv_id": "USDCAD",
        "pair": "USD-CAD",
        "price_precision": 1000000,
        "token0": "USD",
        "token1": "CAD",
        "full_name": "United States Dollar",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/USDC.svg",
        "pythId": "0x3112b03a41c910ed446852aacf67118cb1bec67b2cd0b9a214c58cc0eaa2ecca",
        "pythGroup": "FX",
        "expo": 5,
    },
    "ARBUSD": {
        "category": "Crypto",
        "tv_id": "ARBUSD",
        "pair": "ARB-USD",
        "price_precision": 10000,
        "token0": "ARB",
        "token1": "USD",
        "full_name": "Arbitrum",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/arb.svg",
        "pythId": "0x3fa4252848f9f0a1480be62745a4629d9eb1322aebab8a791e344b3b9c1adcf5",
        "pythGroup": "Crypto",
        "expo": 8,
    },
    "BNBUSD": {
        "category": "Crypto",
        "tv_id": "BNBUSD",
        "pair": "BNB-USD",
        "price_precision": 100,
        "token0": "BNB",
        "token1": "USD",
        "full_name": "Binance Coin",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/bnb.svg",
        "pythId": "0x2f95862b045670cd22bee3114c39763a4a08beeb663b145d283c31d7d1101c4f",
        "pythGroup": "Crypto",
        "expo": 8,
    },
    "MATICUSD": {
        "category": "Crypto",
        "tv_id": "MATICUSD",
        "pair": "MATIC-USD",
        "price_precision": 100,
        "token0": "MATIC",
        "token1": "USD",
        "full_name": "Matic",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/matic.svg",
        "pythId": "0x5de33a9112c2b700b8d30b8a3402c103578ccfa2765696471cc672bd5cf6ac52",
        "pythGroup": "Crypto",
        "expo": 8,
    },
    "OPUSD": {
        "category": "Crypto",
        "tv_id": "OPUSD",
        "pair": "OP-USD",
        "price_precision": 100,
        "token0": "OP",
        "token1": "USD",
        "full_name": "Optimism",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/op.svg",
        "pythId": "0x385f64d993f7b77d8182ed5003d97c60aa3361f3cecfe711544d2d59165e9bdf",
        "pythGroup": "Crypto",
        "expo": 8,
    },
    "XRPUSD": {
        "category": "Crypto",
        "tv_id": "XRPUSD",
        "pair": "XRP-USD",
        "price_precision": 100000,
        "token0": "XRP",
        "token1": "USD",
        "full_name": "Ripple",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/xrp.svg",
        "pythId": "0xec5d399846a9209f3fe5881d70aae9268c94339ff9817e8d18ff19fa05eea1c8",
        "pythGroup": "Crypto",
        "expo": 8,
    },
    "DOGEUSD": {
        "category": "Crypto",
        "tv_id": "DOGEUSD",
        "pair": "DOGE-USD",
        "price_precision": 100000,
        "token0": "DOGE",
        "token1": "USD",
        "full_name": "Dogecoin",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/doge.svg",
        "pythId": "0xdcef50dd0a4cd2dcc17e45df1676dcb336a11a61c69df7a0299b0150c672d25c",
        "pythGroup": "Crypto",
        "expo": 8,
    },
    "TONUSD": {
        "category": "Crypto",
        "tv_id": "TONUSD",
        "pair": "TON-USD",
        "price_precision": 10000,
        "token0": "TON",
        "token1": "USD",
        "full_name": "TON",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/ton.svg",
        "pythId": "0x8963217838ab4cf5cadc172203c1f0b763fbaa45f346d8ee50ba994bbcac3026",
        "pythGroup": "Crypto",
        "expo": 8,
    },
    "SHIBUSD": {
        "category": "Crypto",
        "tv_id": "SHIBUSD",
        "pair": "SHIB-USD",
        "price_precision": 1000000000,
        "token0": "SHIB",
        "token1": "USD",
        "full_name": "Shiba Inu",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/shib.svg",
        "pythId": "0xf0d57deca57b3da2fe63a493f4c25925fdfd8edf834b20f93e1f84dbd1504d4a",
        "pythGroup": "Crypto",
        "expo": 10,
    },
    "USDSGD": {
        "category": "Forex",
        "tv_id": "USDSGD",
        "pair": "USD-SGD",
        "price_precision": 1000000,
        "token0": "USD",
        "token1": "SGD",
        "full_name": "United States Dollar",
        "img": "https://cdn.buffer.finance/Buffer-Website-Data/main/Assets/USDC.svg",
        "pythGroup": "FX",
        "pythId": "0x396a969a9c1480fa15ed50bc59149e2c0075a72fe8f458ed941ddec48bdb4918",
        "expo": 5,
    },
}


auth_msg_raw = "Sign to verify your user address with Buffer Finance v2.5 on Arbitrum One and Arbitrum Goerli"
